//importing packages from d3
import { select, json, geoPath, geoNaturalEarth1 } from 'd3';

//importing feature method from TopoJSON package
import { feature } from 'topojson';

//we create an svg element below
const svg = select('svg');

//'geoNaturalEarth1()' function to potray a view of earth which is natural
const projection = geoNaturalEarth1();
//demonstrating how our world map should look like
const pathGenerator = geoPath().projection(projection);

//adding path instructions SVG with attribute class as 'earth' and pathGenerator as Sphere 
svg.append('path')
    .attr('class', 'earth')
    .attr('d', pathGenerator({type: 'Sphere'}));

//linking .json file having data and coordinates required to display map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries); 
//'selectAll()' function is used to select all the elements.
    svg.selectAll('path').data(countries.features)
//enter() access the lonely data points and append will add path for them.
      .enter().append('path')
        .attr('class', 'countries')
        .attr('d', pathGenerator);
  });